---
- name: "create target directory"
  ansible.builtin.file:
    state: "directory"
    path: "{{ path }}"
  loop:
    - "{{ component.name }}"
  loop_control:
    label: "{{ path }}"
  vars:
    path: "{{ '%s/.tmp/%s/%s/' | format(playbook_dir, kubeinstaller.context, component.name) }}"

- name: "render installer files"
  ansible.builtin.template:
    src: "{{ src }}"
    dest: "{{ dest }}"
  loop:
    - "Chart.yaml"
    - "values.yaml"
  loop_control:
    loop_var: "filename"
  vars:
    src: "{{ '%s/templates/%s.j2' | format(ansible_parent_role_paths[0], filename) }}"
    dest: "{{ '%s/.tmp/%s/%s/%s' | format(playbook_dir, kubeinstaller.context, component.name, filename) }}"
    repository: "{{ 'file://%s/charts' | format(ansible_parent_role_paths[0]) }}"

- name: "helm dependency update"
  ansible.builtin.shell:
    cmd: "helm dependency update"
    chdir: "{{ path }}"
  changed_when: false
  loop:
    - "{{ component.name }}"
  loop_control:
    label: "{{ path }}"
  vars:
    path: "{{ '%s/.tmp/%s/%s/' | format(playbook_dir, kubeinstaller.context, component.name) }}"

- name: "install"
  kubernetes.core.helm:
    chart_ref: "{{ chart_ref }}"
    context: "{{ kubeinstaller.context }}"
    create_namespace: true
    release_name: "{{ component.name }}"
    release_namespace: "{{ component.namespace }}"
    force: true
    values_files:
      - "{{ values_file }}"
  loop:
    - "{{ component.name }}"
  vars:
    chart_ref: "{{ '%s/.tmp/%s/%s/' | format(playbook_dir, kubeinstaller.context, component.name) }}"
    values_file: "{{ '%s/.tmp/%s/%s/values.yaml' | format(playbook_dir, kubeinstaller.context, component.name) }}"
